/*
 *	Qizx/Open version 0.4
 *
 *	Copyright (c) 2003-2004 Xavier C. FRANC -- All rights reserved.
 *
 *	This program is free software; you can redistribute it  and/or
 *	modify it under the terms of the GNU General Public License as
 *	published by the Free Software Foundation (see LICENSE.txt).
 */

package net.xfra.qizxopen.xquery.fn;
import net.xfra.qizxopen.xquery.impl.*;

import net.xfra.qizxopen.util.*;
import net.xfra.qizxopen.xquery.*;
import net.xfra.qizxopen.xquery.dm.DistinctNodeSequence;

/**
 *  Implementation of function fn:distinct-nodes.
 */
public class DistinctNodes extends Function {

    static Prototype[] protos = { 
        Prototype.fn("distinct-nodes", Type.NODE.star, Exec.class)
            .arg("srcval", Type.NODE.star)
    };

    public Prototype[] getProtos() { return protos; }

    public static class Exec extends Function.Call {

        public Value eval(Focus focus, EvalContext context) throws XQueryException {
            context.at(this);
            return new DistinctNodeSequence( args[0].eval(focus, context) );
        }
    }
}
