/*
 *	Qizx/Open version 0.4
 *
 *	Copyright (c) 2003-2004 Xavier C. FRANC -- All rights reserved.
 *
 *	This program is free software; you can redistribute it  and/or
 *	modify it under the terms of the GNU General Public License as
 *	published by the Free Software Foundation (see LICENSE.txt).
 */


package net.xfra.qizxopen.xquery.fn;
import net.xfra.qizxopen.xquery.impl.*;

import net.xfra.qizxopen.xquery.*;

/**
 *  Implementation of function fn:zero-or-one.
 */
public class ZeroOrOne extends Function {

    static Prototype[] protos = { 
        Prototype.fn("zero-or-one", Type.ITEM.opt, Exec.class) .arg("srcval", Type.ITEM.star)
    };
    public Prototype[] getProtos() { return protos; }

    public static class Exec extends Function.Call {

        public Value eval(Focus focus, EvalContext context) throws XQueryException {
            context.at(this);
	    Value value = args[0].eval(focus, context);
	    try {
		value = Type.ITEM.opt.check(value);
	    } catch (TypeException err) {
		context.error(this, err);
	    }
	    return value;
        }
    }
}
